﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Diagram_UserControl
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.Resources.Add("userControlTemplate", CreateUserControlDataTemplate());

            DiagramNode node1 = new DiagramNode();
            node1.Height = 100;
            node1.Width = 150;
            node1.Position = new Point(200, 20);
            node1.Geometry = FindResource("CustomGeometry") as GeometryGroup;
            node1.DisplayTemplate = FindResource("userControlTemplate") as DataTemplate;

            DiagramNode node2 = new DiagramNode();
            node2.Height = 100;
            node2.Width = 150;
            node2.Position = new Point(200, 200);
            node2.Geometry = FindResource("CustomGeometry") as GeometryGroup;
            node2.DisplayTemplate = FindResource("UserControl2") as DataTemplate;

            DiagramConnection nodeConnection1 = new DiagramConnection();
            nodeConnection1.StartNode = node1;
            nodeConnection1.EndNode = node2;
            nodeConnection1.ConnectionType = DiagramConnectionType.Straight;

            this.igDiagram.Items.Add(node1);
            this.igDiagram.Items.Add(node2);
            this.igDiagram.Items.Add(nodeConnection1);
        }

        public static DataTemplate CreateUserControlDataTemplate()
        {
            var rectangleFactory = new FrameworkElementFactory(typeof(UserControl1));

            return new DataTemplate
            {
                VisualTree = rectangleFactory,
            };
        }
    }
}
